module l6p4 (clk, rst, step, in, out);

input clk;
input rst;
input step;
input [6:0] in;
output [7:0] out;

wire n_rst;
wire ce;
wire [7:0] n_out;

assign n_rst = ~rst;
assign out = ~n_out;

accum myaccum (.B({1'b0,in}), .CLOCK(clk), .CLK_EN(ce), .ASYNC_CTRL(n_rst), .Q_OUT(n_out));

reg q1, q2, q3;

always @ (posedge clk or posedge n_rst)
  if (n_rst == 1) 
    begin
      q1 <= 1'b0; q2 <= 1'b0; q3 <= 1'b0;
    end
  else
    begin
      q1 <= step; q2 <= q1; q3 <= q2;
    end

assign ce = q1 & q2 & !q3;

endmodule 
